/*
 * $Id: config.cpp,v 1.2 2004/05/01 22:50:34 fredrik Exp $
 * 
 * OpusOs KWin client configuration module
 *
 * Copyright (C) 2002 Fredrik H�lund <fredrik@kde.org>
 *
 * Based on the Quartz configuration module,
 *     Copyright (c) 2001 Karol Szwed <gallium@kde.org>
 *  
 * OpusOs KWin client (version 1.0a)
 *
 * Copyright (C) 2004 Jose Rafael Castillo <jrch99@cantv.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the license, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <kglobal.h>
#include <klocale.h>

#include <qcheckbox.h>
#include <qradiobutton.h>
#include <kcolorbutton.h>
#include <qcombobox.h>
#include <qslider.h>
#include <qcolor.h>
#include <qfiledialog.h>
#include <qlineedit.h>
#include <qdir.h>
#include <qlabel.h>
#include "config.h"
#include "config.moc"

extern "C"
  {
    QObject* allocate_config( KConfig* conf, QWidget* parent )
    {
      return ( new OpusOsConfig( conf, parent ) );
    }
  }


/* NOTE:
 * 'conf' 	is a pointer to the kwindecoration modules open kwin config,
 *			and is by default set to the "Style" group.
 *
 * 'parent'	is the parent of the QObject, which is a VBox inside the
 *			Configure tab in kwindecoration
 */

OpusOsConfig::OpusOsConfig( KConfig* conf, QWidget* parent )
    : QObject( parent )
{
  KGlobal::locale()->insertCatalogue("kwin_OpusOs_config");
  c = new KConfig( "kwinOpusOsrc" );
  ui = new OpusOsConfigUI( parent );
  //connect( ui->comboBox1, SIGNAL(activated(const QString &)), this, SLOT(EnableURL(const QString &)));
  connect( ui->showAppIcons,    SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->largeGrabBars,   SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->useShadowedText, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->shadow1, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->shadow2, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->shadow3, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->left, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->right, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->center, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->systemcolor, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->originalcolor, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->effectvalue, SIGNAL(sliderReleased()), SIGNAL(changed()) );
  connect( ui->effectcolor, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->ShadowColor, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->togray, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->gamma, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->desaturate, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->colorize, SIGNAL(clicked()), SIGNAL(changed()) );
  connect( ui->semitransparent, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->defaultavatar, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->customavatar, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->pushButton1, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->defaultfunctionavatar, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->radioButton19, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->options, SIGNAL(returnPressed()), SIGNAL(changed()) );
  //connect( ui->pushButton1, SIGNAL(clicked()), this, SLOT(openFileDialog()) );
  connect( ui->ishadowcolor, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->normalsize, SIGNAL(clicked()), SIGNAL(changed()) );
  //connect( ui->hugesize, SIGNAL(clicked()), SIGNAL(changed()) );
  //static const char *Programas[] =
  //  {"Konqueror", "Kontact", "Kopete", "Kaffeine", "AmaroK", "KControl", "Juk", 0
  //  };
  //ui->comboBox1->insertStrList( Programas );
  //ui->options->setEnabled(false);
  load( conf );
  ui->show();
}


OpusOsConfig::~OpusOsConfig()
{
  delete ui;
  delete c;
}

void OpusOsConfig::openFileDialog()
{
  //ui->lineEdit2->setText(QFileDialog::getOpenFileName(
                           //c->readEntry("CustomAvatarPix", QString::null),
                           //"Avatar Pixmaps(*.png)",
                           //ui->pushButton1,
                           //"open file dialog",
                           //"Choose an Avatar Pixmap" ));
  //ui->imagen->setPixmap(QPixmap(ui->lineEdit2->text()));
}
// Loads the configurable options from the kwinrc config file
// It is passed the open config from kwindecoration to improve efficiency
void OpusOsConfig::load( KConfig* )
{
  c->setGroup("General");
  ui->showAppIcons->setChecked( c->readBoolEntry("ShowAppIcons", true) );
  //ui->largeGrabBars->setChecked( c->readBoolEntry("LargeGrabBars", false) );
  ui->useShadowedText->setChecked( c->readBoolEntry("UseShadowedText", true) );
  ui->semitransparent->setChecked( c->readBoolEntry( "UseIconTransparent", false ) );
  ui->ShadowColor->setColor(c->readColorEntry("UseShadowedTextColor"));
  ui->ishadowcolor->setColor(c->readColorEntry("UseShadowedInactiveTextColor"));
  ui->effectcolor->setColor(c->readColorEntry("UseIconColor"));
  ui->effectvalue->setValue(c->readNumEntry("EffectValue", 50));
  Read_Config.textpos = c->readNumEntry("TextPosition", 0);
  Read_Config.shadowtype = c->readNumEntry("UseShadowedTextType", 1);
  Read_Config.coloroption = c->readNumEntry("UseColorOption", 0);
  Read_Config.effects = c->readNumEntry("Effect", 0);
  //ui->lineEdit2->setText( c->readEntry("CustomAvatarPix", QString::null));
  //ui->options->setText( c->readEntry( "AvatarFuncURL", "www.OpusOs.com"));
  //ui->comboBox1->setCurrentText( c->readEntry("AvatarFuncType", "Konqueror"));
  Read_Config.ava = c->readNumEntry("Avatar", 0);
  Read_Config.avafunc = c->readNumEntry("AvatarFunc", 0);
  //ui->imagen->setPixmap(QPixmap(ui->lineEdit2->text()));
  Read_Config.tsize = c->readBoolEntry( "ThemeSize", false);

  //if(Read_Config.tsize)
    //ui->hugesize->setChecked( true );
  //else
    //ui->normalsize->setChecked( true );

  //if(Read_Config.ava == 0)
    //ui->defaultavatar->setChecked( true );
  //else
    //ui->customavatar->setChecked( true );
  //if(Read_Config.avafunc == 0)
    //ui->defaultfunctionavatar->setChecked( true );
  //else
    //ui->radioButton19->setChecked( true );
  if(Read_Config.textpos == 0)
    {
      ui->left->setChecked(true);
    }
  else if(Read_Config.textpos == 1)
    {
      ui->center->setChecked(true);
    }
  else if(Read_Config.textpos == 2)
    {
      ui->right->setChecked(true);
    }
  if  (Read_Config.shadowtype == 1)
    {
      ui->shadow1->setChecked(true);
    }
  else if  (Read_Config.shadowtype == 2)
    {
      ui->shadow2->setChecked(true);
    }
  else if  (Read_Config.shadowtype == 0)
    {
      ui->shadow3->setChecked(true);
    }
  if (Read_Config.effects == 0)
    {
      ui->togray->setChecked(true);
    }
  else if (Read_Config.effects == 1)
    {
      ui->colorize->setChecked(true);
    }
  else if (Read_Config.effects == 2)
    {
      ui->gamma->setChecked(true);
    }
  else if (Read_Config.effects == 3)
    {
      ui->desaturate->setChecked(true);
    }
}

// Saves the configurable options to the kwinrc config file
void OpusOsConfig::save( KConfig* )
{
  if (ui->left->isChecked())
    {
      Config_Params.position=0;
    }
  else if (ui->center->isChecked())
    {
      Config_Params.position =1;
    }
  else if (ui->right->isChecked())
    {
      Config_Params.position =2;
    }
  if (ui->shadow1->isChecked())
    {
      Config_Params.shadowtype = 1;
    }
  else if (ui->shadow2->isChecked())
    {
      Config_Params.shadowtype = 2;
    }
  else if (ui->shadow3->isChecked())
    {
      Config_Params.shadowtype = 0;
    }
  //0=togray 1= colorize 2=gamma 3=desaturate
  if(ui->togray->isChecked())
    {
      Config_Params.effect = 0;
    }
  else if(ui->colorize->isChecked())
    {
      Config_Params.effect = 1;
    }
  else if(ui->gamma->isChecked())
    {
      Config_Params.effect = 2;
    }
  else if(ui->desaturate->isChecked())
    {
      Config_Params.effect = 3;
    }
  //if (ui->defaultavatar->isChecked())
    //{
      //Config_Params.avatar = 0;
    //}
  //else if(ui->customavatar->isChecked())
    //{
      //Config_Params.avatar = 1;
    //}
  //if (ui->defaultfunctionavatar->isChecked())
    //{
      //Config_Params.avatarfunc = 0;
    //}
  //else if (ui->radioButton19->isChecked())
    //{
      //Config_Params.avatarfunc = 1;
    //}
  //if(Config_Params.avatarfunc == 0)
    //{
      //Config_Params.Type = "Konqueror";
      //Config_Params.Func = "http://www.OpusOs.com";
    //}
  //else
    //{
      //Config_Params.Type = ui->comboBox1->currentText();
      //Config_Params.Func = ui->options->text();
    //}
  
  bool size;
  //if(ui->normalsize->isChecked())
    //size = false;
  //else if (ui->hugesize->isChecked())
    //size=true;

  //ui->imagen->setPixmap(QPixmap(ui->lineEdit2->text()));
  c->setGroup( "General" );
  c->writeEntry( "ShowAppIcons", ui->showAppIcons->isChecked() );
  //c->writeEntry( "LargeGrabBars", ui->largeGrabBars->isChecked() );
  c->writeEntry( "TextPosition", Config_Params.position );
  c->writeEntry( "UseShadowedText", ui->useShadowedText->isChecked() );
  c->writeEntry( "UseShadowedTextColor", ui->ShadowColor->color() );
  c->writeEntry( "UseShadowedInactiveTextColor", ui->ishadowcolor->color() );
  c->writeEntry( "UseShadowedTextType", Config_Params.shadowtype );
  c->writeEntry( "UseIconTransparent", ui->semitransparent->isChecked() );
  c->writeEntry( "UseIconColor", ui->effectcolor->color() );
  c->writeEntry( "EffectValue", ui->effectvalue->value() );
  c->writeEntry( "Effect", Config_Params.effect );
  c->writeEntry( "UseColorOption", Config_Params.coloropt );
  c->writeEntry( "Avatar", Config_Params.avatar);
  c->writeEntry( "AvatarFunc", Config_Params.avatarfunc);
  //c->writeEntry( "CustomAvatarPix", ui->lineEdit2->text());
  c->writeEntry( "AvatarFuncType", Config_Params.Type );
  c->writeEntry( "AvatarFuncURL", Config_Params.Func);
  c->writeEntry( "ThemeSize", size);
  c->sync();
}

// Sets UI widget defaults which must correspond to style defaults
void OpusOsConfig::defaults()
{
  ui->showAppIcons->setChecked( true );
  ui->useShadowedText->setChecked( true );
  //ui->largeGrabBars->setChecked( false );
  ui->left->setChecked(true);
  ui->shadow2->setChecked(true);
  //ui->originalcolor->setChecked(true);
  ui->effectvalue->setValue(50);
  ui->togray->setChecked(true);
  ui->ShadowColor->setColor(QColor(213, 213, 221));
  ui->ishadowcolor->setColor(QColor(213, 213, 221));
  ui->effectcolor->setColor(QColor(0, 0, 0));
  //ui->defaultavatar->setChecked( true );
  //ui->defaultfunctionavatar->setChecked( true );
  //ui->normalsize->setChecked( true );
  emit changed();
}

void OpusOsConfig::EnableURL(const QString &compa)
{
  //if (compa == "Konqueror")
    //{
      //ui->options->setEnabled(true);
    //}
  //else
    //ui->options->setEnabled(false);
  //ui->imagen->setPixmap(QPixmap(ui->lineEdit2->text()));
}

// vim: set noet ts=4 sw=4:
